<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/13/2004 *
 * ===============                              Last change: 08/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : overview-inc.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Output standard task management                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Standart-Aufgaben-Management ausgeben            *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) || (!IS_ADMIN()))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

function OUTPUT_STANDARD_OVERVIEW(&$result_tasks)
{
	global $EXTENSIONS, $KEEP_ACTIVE;

	// First check for solved and not assigned tasks and assign them to current admin
	$result_task = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_task_system SET assigned_admin='%s' WHERE assigned_admin < 1 AND status != 'NEW'",
	 array(GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);

	// We currently don't want to install an extension so let's find out if we need...
	$EXT_LOAD_MODE = "register"; $JOBS_DONE = true;

	// Open the extension directory
	$handle = opendir(PATH."inc/extensions/") or mxchange_die("Cannot read extension directory!");
	while ($file = readdir($handle)) {
		// Is this file an extension?
		if ((substr($file, 0, 4) == "ext-") && (substr($file, -4) == ".php")) {
			//* DEBUG: */ echo $file."<br />\n";
			// Possible newly installed extension found so we extract extension's name
			$ext = strtolower(substr($file, 4, -4)); // Keep always extension names on lower case!!!

			// Check if extension is installed or not
			$ext_ver = "";
			if ((!is_array($EXTENSIONS['ext_version'])) || (empty($EXTENSIONS['ext_version'][$ext]))) {
				// Load data from database
				$result = SQL_QUERY_ESC("SELECT id, ext_version FROM "._MYSQL_PREFIX."_extensions WHERE ext_name='%s' LIMIT 1",
				 array($ext), __FILE__, __LINE__);
			} else {
				// Load version from cache
				if (!empty($EXTENSIONS['ext_version'][$ext])) {
					// Extension is installed so we can get it's version number
					$ext_ver = $EXTENSIONS['ext_version'][$ext];
				} else {
					// Extension is not installed so no version number was found
					$ext_ver = "";
				}

				// Disable load from database
				$result = false;
			}

			// Is the extension not yet installed?
			if ((SQL_NUMROWS($result) == 0) && (empty($ext_ver))) {
				// Not installed and do we have created a task for the admin?
				$ext_subj = "[".$ext.":] ".ADMIN_NEW_EXT_SUBJ;
				//* DEBUG: */ echo $ext.":".$ext_ver."=";
				$result = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_task_system WHERE subject='%s' LIMIT 1",
				 array($ext_subj), __FILE__, __LINE__);
				//* DEBUG: */ echo SQL_NUMROWS($result)."<br />\n";
				if ((SQL_NUMROWS($result) == 0) && (GET_EXT_VERSION($ext) == ""))
				{
					// Template file
					$tpl = sprintf("%stemplates/%s/html/ext/ext_%s.tpl",
						PATH,
						GET_LANGUAGE(),
						$ext
					);

					// Load text for task
					if ((file_exists($tpl)) && (is_readable($tpl)))
					{
						// Load extension's own text template (HTML!)
						$MSG = LOAD_TEMPLATE("ext_".$ext, true);
					}
					 else
					{
						// Load default message
						$MSG = LOAD_EMAIL_TEMPLATE("admin_new_ext","", 0);
					}

					// Task not created so it's a brand-new extension which we need to register and create a task for!
					$result = SQL_QUERY_ESC("INSERT INTO "._MYSQL_PREFIX."_task_system (assigned_admin, userid, status, task_type, subject, text, task_created)
VALUES ('%s', '0', 'NEW', 'EXTENSION', '%s', '%s', UNIX_TIMESTAMP())",
 array(
	GET_ADMIN_ID($_COOKIE['admin_login']),
	$ext_subj,
	addslashes($MSG),
),  __FILE__, __LINE__, true, false);
				}

				// Free memory
				SQL_FREERESULT($result);

				// We maybe want to install an extension so let's test-drive it...
				include(PATH."inc/extensions/".$file);
			}
			 else
			{
				// Maybe we want to update?
				if ((empty($EXTENSIONS['ext_version'][$ext])) && (SQL_NUMROWS($result) == 1))
				{
					list($dummy, $ext_ver) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);
				}

				// Update extension
				if (!empty($ext_ver)) EXTENSION_UPDATE($file, $ext, $ext_ver);

				if (!empty($KEEP_ACTIVE[$ext]))
				{
					// Maybe we want to keept the current extension active?
					if (($KEEP_ACTIVE[$ext] == 'Y') && (!EXT_IS_ACTIVE($ext, true, true)))
					{
						// Reactivate this extension!
						$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_extensions SET ext_active='Y' WHERE ext_name='%s' LIMIT 1",
						 array($ext), __FILE__, __LINE__);
						EXTENSION_RUN_SQLS(GET_EXT_ID($ext), "activate");
					}
				}
			}
		}
	}

	// Close directory handle
	closedir($handle);

	// At last - but not least - check for own and new unassigned tasks...
	$result_tasks = SQL_QUERY_ESC("SELECT id, assigned_admin, userid, task_type, subject, text, task_created
FROM "._MYSQL_PREFIX."_task_system
WHERE assigned_admin='%s' OR (assigned_admin='0' AND status='NEW')
ORDER BY userid DESC, task_type DESC, subject, task_created DESC",
	 array(GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
	if (SQL_NUMROWS($result_tasks) > 0)
	{
		// New jobs found!
		$JOBS_DONE = false;
	}

	return $JOBS_DONE;
}
//
function OUTPUT_SELECTED_TASKS($_POST, $result_tasks)
{
	global $CONFIG, $NOTES;
	if ((isset($_POST['assign'])) && (count($_POST['task']) > 0))
	{
		// Assign / do tasks
		$OUT = ""; $SW = 2;
		foreach ($_POST['task'] as $id=>$sel)
		{
			$result_task = SQL_QUERY_ESC("SELECT id, userid, task_type, subject, text, task_created, status, assigned_admin FROM "._MYSQL_PREFIX."_task_system WHERE id=%d AND (assigned_admin='%s' OR (assigned_admin='0' AND status='NEW')) LIMIT 1",
			 array(bigintval($id), GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
			if (SQL_NUMROWS($result_task) == 1)
			{
				// Task is valid...
				list($tid, $uid, $type, $subj, $text, $created, $status, $aid) = SQL_FETCHROW($result_task);
				SQL_FREERESULT($result_task);
				if ($aid == "0")
				{
					// Assgin current admin to unassgigned task
					$result_assign = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_task_system SET assigned_admin='%s' WHERE id=%d LIMIT 1",
					 array(GET_ADMIN_ID($_COOKIE['admin_login']), bigintval($tid)), __FILE__, __LINE__);
				}
				$ADD = "";
				if ($type == "SUPPORT_MEMBER")
				{
					$mode = substr($text, 0, strpos($text, ":"));
					$text = substr($text, strpos($text, ":") + 1);
					$ADD = "<LI>".ADMIN_TASK_SUPPORT_MODE.": <STRONG>".$mode."</STRONG></LI>";
				}
				if ($uid > 0)
				{
					$result_user = SQL_QUERY_ESC("SELECT sex, surname, family, email FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1",
					 array(bigintval($uid)), __FILE__, __LINE__);
					if (SQL_NUMROWS($result_user) == 1)
					{
						list($sex, $sname, $fname, $email) = SQL_FETCHROW($result_user);
						SQL_FREERESULT($result_user);
						$ADD = "<LI>".ADMIN_MEMBER_UID.": <STRONG>".ADMIN_USER_PROFILE_LINK($uid)." (<A href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".TRANSLATE_SEX($sex)." ".$sname." ".$fname."</A>)</STRONG></LI>";
					}
				}

				// Compile and insert text from task into table template
				$text = LOAD_TEMPLATE("admin_extensions_text", true, COMPILE_CODE($text));

				// Initialize variables (no title for SQL commands by default)
				$ext_name = "";
				$title = TASK_NO_TITLE;

				// Shall I list SQL commands assigned to an extension installation or update task?
				if (((GET_EXT_VERSION("sql_patches") != "") && ($CONFIG['verbose_sql'] == 'Y')) || (!EXT_IS_ACTIVE("sql_patches")))
				{
					$ext_name = substr($subj, 1, strpos($subj, ":") - 1);
					if ($type == "EXTENSION")
					{
						// Load SQL commands for registering
						$SQLs = EXTENSION_REGISTER($ext_name, $id, true);

						// Add notes to text
						$text .= $NOTES;

						// Set title
						$title = ADMIN_SQLS_EXECUTED_ON_REGISTER;
					}
					 elseif ($type == "EXTENSION_UPDATE")
					{
						// Load SQL commands for update (already done!)
						$ext_name = substr($ext_name, 7);
						$ext_name = substr($ext_name, 0, strpos($ext_name, "-"));
						$test = "[UPDATE-".$ext_name."-";
						$ext_ver = substr($subj, strlen($test));
						$ext_ver = substr($ext_ver, 0, strpos($ext_ver, ":"));

						// Load SQLs from file
						$SQLs = EXTENSION_UPDATE("ext-".$ext_name.".php", $ext_name, $ext_ver, true);

						// Add notes to text
						$text .= $NOTES;

						// Set title
						$title = ADMIN_SQLS_EXECUTED_ON_UPDATE;
					}
					 else
					{
						// Remove extension's name
						$ext_name = "";
					}

					// Add SQLs to a table
					if (empty($SQLs)) $SQLs = array();
					if (empty($title)) $title = "";
					if ((!empty($ext_name)) && (GET_EXT_VERSION("sql_patches")) && ($CONFIG['verbose_sql'] == 'Y')) {
						// Add verbose SQL table
						$text .= EXTENSION_VERBOSE_TABLE($SQLs, $title, " class=\"admin_table top2 left2 right2\"", true, "100%")."<br />\n";
					}
				}
				 else
				{
					// Run SQL commands in dry mode but only return the notes
					$SQLs = EXTENSION_UPDATE("ext-".$ext_name.".php", $ext_name, $ext_ver, true);
					$text .= $NOTES;
				}

				// Prepare array for the template
				$content = array(
					'sw'        => $SW,
					'subj'      => $subj,
					'add'       => $ADD,
					'text'      => $text,
					'created'   => MAKE_DATETIME($created, "1"),
					'extension' => $ext_name
				);

				// Load template
				$OUT .= LOAD_TEMPLATE("admin_overview_row", true, $content);

				// Which task do we actually have here?
				switch ($type)
				{
				case "EXTENSION": // Install new extensions
					$ext_name = substr($subj, 1, strpos($subj, ":") - 1);
					$result_lines = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_extensions WHERE ext_name='%s' LIMIT 1",
					 array($ext_name), __FILE__, __LINE__);
					$lines = SQL_NUMROWS($result_lines);
					SQL_FREERESULT($result_lines);
					if ($lines == "0")
					{
						// New extension found
						$OUT .= LOAD_TEMPLATE("admin_ext_reg_form", true, array(
							'id'       => bigintval($id),
							'ext_name' => $ext_name
						));
  					}
					 else
					{
						// Task is closed so nothing is todo
						$OUT .= "<FONT class=\"admin_failed\">".ADMIN_EXT_ALREADY_REGISTERED."</FONT>\n";

						// Close task but not already closes or deleted or update tasks
						if (($status != "CLOSED") && ($status != "DELETED") && ($type != "EXTENSION_UPDATE"))
						{
							$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_task_system SET status='SOLVED' WHERE id=%d LIMIT 1",
							 array(bigintval($tid)), __FILE__, __LINE__);
						}
					}
					break;

				case "EXTENSION_UPDATE":
					// Extension updates are installed automatically
					$OUT .= "<FONT class=\"admin_failed medium\">".ADMIN_EXTENSION_UPDATED."</FONT>\n";

					// Close task
					if (($status != "CLOSED") && ($status != "DELETED"))
					{
						$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_task_system SET status='SOLVED' WHERE id=%d LIMIT 1",
						 array(bigintval($tid)), __FILE__, __LINE__);
					}
					break;

				case "SUPPORT_MEMBER": // Assign on member's support request
					switch ($mode)
					{
					default: // Unknown support mode
						$OUT .= "<FONT class=\"admin_failed medium\">".ADMIN_UNKNOWN_SUPPORT_MODE_1.$mode.ADMIN_UNKNOWN_SUPPORT_MODE_2."</FONT>\n";
						break;
					}
					break;

				case "PAYOUT_REQUEST": // Payout requests
					if (EXT_IS_ACTIVE("payout"))
					{
						// Extension is installed so let him send a notification to the user
						$result_pay = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_user_payouts WHERE userid=%d AND payout_timestamp=%d LIMIT 1",
						 array(bigintval($uid), bigintval($created)), __FILE__, __LINE__);
						list($pid) = SQL_FETCHROW($result_pay);
						SQL_FREERESULT($result_pay);

						if ((!empty($pid)) && ($pid > 0))
						{
							// Payout ID can be obtained
							$content = array(
								'pid' => $pid,
								'tid' => $tid,
							);
							$OUT .= LOAD_TEMPLATE("admin_payout_overview_form", true, $content);
						}
						 else
						{
							// Problem obtaining payout ID
							$OUT .= "<FONT class=\"admin_failed medium\">".PAYOUT_OBTAIN_ID_FAILED."</FONT>\n";
						}
					}
					 else
					{
						// Extension is not installed
						$OUT .= "<FONT class=\"admin_failed medium\">".ADMIN_PAYOUT_NOT_INSTALLED."</FONT>\n";
					}
					break;

				case "WERNIS_REQUEST": // Wernis requests
					if (EXT_IS_ACTIVE("wernis"))
					{
						// Extension is installed so let him send a notification to the user
						$result_pay = SQL_QUERY_ESC("SELECT id FROM "._MYSQL_PREFIX."_user_wernis WHERE userid=%d AND wernis_timestamp=%d LIMIT 1",
						 array(bigintval($uid), bigintval($created)), __FILE__, __LINE__);
						list($pid) = SQL_FETCHROW($result_pay);
						SQL_FREERESULT($result_pay);

						if ((!empty($pid)) && ($pid > 0))
						{
							// Payout ID can be obtained
							$content = array(
								'pid' => $pid,
								'tid' => $tid,
							);
							$OUT .= LOAD_TEMPLATE("admin_wernis_overview_form", true, $content);
						}
						 else
						{
							// Problem obtaining wernis ID
							$OUT .= "<FONT class=\"admin_failed medium\">".WERNIS_OBTAIN_ID_FAILED."</FONT>\n";
						}
					}
					 else
					{
						// Extension is not installed
						$OUT .= "<FONT class=\"admin_failed medium\">".ADMIN_WERNIS_NOT_INSTALLED."</FONT>\n";
					}
					break;

				case "HOLIDAY_REQUEST": // Holiday requests
					$OUT .= LOAD_TEMPLATE("admin_task_holiday", true, $uid);
					break;

				case "NL_UNSUBSCRIBE": // Newsletter unsubscriptions
					$result = SQL_QUERY_ESC("SELECT nl_timespan FROM "._MYSQL_PREFIX."_user_data WHERE userid=%d LIMIT 1",
					 array(bigintval($uid)), __FILE__, __LINE__);
					list($span) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);

					if ($span > 0)
					{
						// Undone unscubscribe request
						$content = array(
							'uid' => $uid,
							'id'  => $tid
						);
						$OUT .= LOAD_TEMPLATE("admin_newsletter_tsk", true, $content);
					}
					 else
					{
						// Already unsubscribed
						$OUT .= "<FONT class=\"admin_failed medium\">".ADMIN_NL_UNSUBSCRIBE_ALREADY."</FONT>\n";
					}
					break;

				default: // Unknown task type
					$OUT .= "<FONT class=\"admin_failed medium\">".ADMIN_UNKNOWN_TASK_TYPE_1.$type.ADMIN_UNKNOWN_TASK_TYPE_2.$id.ADMIN_UNKNOWN_TASK_TYPE_3."</FONT>\n";
					break;
				}
				$OUT .= "  </TD>
  <TD width=\"1%\" class=\"switch_sw".$SW." bottom2 right2\">&nbsp;</TD>
</TR>\n";
			}
			$SW = 3 - $SW;
		}
		define('__TASK_ROWS', $OUT);

		// Load final template
		LOAD_TEMPLATE("admin_overview_list");
	}
	 else
	{
		if ((isset($_POST['task'])) && ((sizeof($_POST['task']) > 0) || ($_POST['task'][0] == "1")))
		{
			// Only unassign / delete tasks when there are selected tasks posted
			if (!empty($_POST['unassign']))
			{
				// Unassign from tasks
				foreach ($_POST['task'] as $id=>$sel)
				{
					$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_task_system SET assigned_admin='0' WHERE id=%d AND assigned_admin='%s' LIMIT 1",
					 array(bigintval($id), GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
				}
			}
			 elseif (isset($_POST['del']))
			{
				// Delete tasks
				foreach ($_POST['task'] as $id=>$sel)
				{
					$result = SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_task_system WHERE id=%d AND (assigned_admin='%s' OR assigned_admin='0') LIMIT 1",
					 array(bigintval($id), GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
				}
			}

			// Update query
			$result_tasks = SQL_QUERY_ESC("SELECT id, assigned_admin, userid, task_type, subject, text, task_created FROM "._MYSQL_PREFIX."_task_system WHERE assigned_admin='%s' OR (assigned_admin='0' AND status='NEW') ORDER BY task_created DESC",
			 array(GET_ADMIN_ID($_COOKIE['admin_login'])), __FILE__, __LINE__);
		}

		// There are uncompleted jobs!
		LOAD_TEMPLATE("admin_overview_header");
		$SW = 2;
		while (list($id, $admin, $uid, $type, $subj, $text, $created) = SQL_FETCHROW($result_tasks))
		{
			$infos = "---";
			if ($admin == "0")
			{
				// No admin currently is assigned
				$admin = "<FONT class=\"admin_note\">".ADMIN_NO_ADMIN_ASSIGNED."</FONT>";
			}
			 else
			{
				// Load admin's data
				$login = GET_ADMIN_LOGIN($admin);
				if ($login != "***")
				{
					// Admin found
					$admin = "<A href=\"".URL."/modules.php?module=admin&amp;what=admins_contct&amp;admin=".$admin."\">".$login."</A>";
				}
				 else
				{
					// Maybe deleted?
					$admin = "<FONT class=\"admin_note\">".ADMIN_ID_404_1.$admin.ADMIN_ID_404_2."</FONT>";
				}
			}
			$evl = "\$type_out = ADMIN_TASK_IS_".strtoupper($type).";";
			eval($evl);
			$type2 = substr($text, 0, strpos($text, ":"));
			// Generate infos
			switch ($type)
			{
			case "EXTENSION":
			case "EXTENSION_UPDATE":
				$infos = substr($subj, 1, strpos($subj, ":") - 1);
				break;
			}
			if ($uid > 0)
			{
				// Member found otherwise it's a system task
				$uid = ADMIN_USER_PROFILE_LINK($uid);
			}
			 else
			{
				$uid = "<I>".ADMIN_IS_SYSTEM_TASK."</I>";
			}

			$content = array(
				'sw'      => $SW,
				'id'      => $id,
				'admin'   => $admin,
				'infos'   => $infos,
				'uid'     => $uid,
				'type'    => $type_out,
				'created' => MAKE_DATETIME($created, "2")
			);

			LOAD_TEMPLATE("admin_overview_list_rows", false, $content);
			$SW = 3 - $SW;
		}
		// Free memory
		SQL_FREERESULT($result_tasks);

		// Load footer template
		LOAD_TEMPLATE("admin_overview_footer");
	}
}
//
?>
